/*
* @(#)Janela.java  1.0  30/03/2001
*	
* Aline Vieira de Mello
* Pontifcia Universidade Catlica do Rio Grande do Sul - Faculdade de Informtica
*/

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
* <i>FiltraArquivos</i> filtra apresentando todos os diretrios e
* arquivos com a extenso especificada.
*/
public class FiltraArquivos extends FileFilter
{
	private String ext;
		
	public FiltraArquivos(String ext)
	{
		this.ext=ext;	
	}
	
  public boolean accept(File f)
  {
    if (f.isDirectory())
      return true;
    
    String arquivo=f.getName();
    String extension="";
       
    int i = arquivo.lastIndexOf('.');

    if (i > 0 &&  i < arquivo.length() - 1)
      extension=arquivo.substring(i+1).toLowerCase();
       
    if (extension != null)
    {
      if (extension.equals(ext))
          return true;
      else
          return false;
    }
    return false;
  }
    
  // Descrio do files of type
  public String getDescription()
  {
    String ponto=".";
    return ponto.concat(ext);
  }
}